/*
 * ADI operations for SPARC Linux
 *
 * Copyright (c) 2014 Oracle Corporation.  All rights reserved.
 *
 * The Universal Permissive License (UPL), Version 1.0
 *
 * Subject to the condition set forth below, permission is hereby
 * granted to any person obtaining a copy of this software, associated
 * documentation and/or data (collectively the "Software"), free of
 * charge and under any and all copyright rights in the Software, and
 * any and all patent rights owned or freely licensable by each licensor
 * hereunder covering either (i) the unmodified Software as contributed
 * to or provided by such licensor, or (ii) the Larger Works (as defined
 * below), to deal in both
 *
 * (a) the Software, and
 *
 * (b) any piece of software and/or hardware listed in the lrgrwrks.txt
 * file if one is included with the Software (each a “Larger Work” to
 * which the Software is contributed by such licensors),
 *
 * without restriction, including without limitation the rights to copy,
 * create derivative works of, display, perform, and distribute the
 * Software and make, use, sell, offer for sale, import, export, have
 * made, and have sold the Software and the Larger Work(s), and to
 * sublicense the foregoing rights on either these or other terms.
 *
 * This license is subject to the following condition:
 *
 * The above copyright notice and either this complete permission notice
 * or at a minimum a reference to the UPL must be included in all copies
 * or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

#ifndef	_ADI_H
#define	_ADI_H

#include <sys/types.h>

/* ADI specific si_code */
#ifndef SEGV_ACCADI
#define SEGV_ACCADI	3
#endif
#ifndef SEGV_ADIDERR
#define SEGV_ADIDERR	4
#endif
#ifndef SEGV_ADIPERR
#define SEGV_ADIPERR	5
#endif

#define ADI_PRECISE_ENABLE      1
#define ADI_PRECISE_DISABLE     0

#define ADI_ENABLE      1
#define ADI_DISABLE     0

/* ELF Auxiliary vectors */
#ifndef AT_ADI_BLKSZ
#define AT_ADI_BLKSZ    34
#endif
#ifndef AT_ADI_NBITS
#define AT_ADI_NBITS    35
#endif
#ifndef AT_ADI_UEONADI
#define AT_ADI_UEONADI  36
#endif

extern int adi_set_enabled(int);
extern int adi_get_enabled(void);

extern caddr_t adi_set_version(caddr_t, unsigned long, int);
extern int adi_get_version(caddr_t);
extern caddr_t adi_clr_version(caddr_t, unsigned long);

extern int adi_version_max(void);
extern int adi_version_nbits(void);

extern int adi_get_precise(void);
extern int adi_set_precise(int);

extern int adi_blksz(void);

extern caddr_t adi_memset(caddr_t, int, unsigned long, int);

#endif /* _ADI_H */
